from machine import I2C, Pin, Timer
import ads1x15 

import constants
import parameters


class PressureSensor:

    _I2C = I2C(1, scl=Pin(constants.PRESSURE_SENSOR_ADC_SCL), sda=Pin(constants.PRESSURE_SENSOR_ADC_SDA), freq=400000)
    _I2C_ADDR = _I2C.scan()[0]
    _ADC = ads1x15.ADS1115(_I2C, _I2C_ADDR, 0)
    _SMOOTH_FACTOR = parameters.PRESSURE_SMOOTH_LENGTH * constants.ADC_RESOLUTION / constants.MAX_PRESSURE_SENSOR_VOTLAGE

    @staticmethod
    def read():
        measure = PressureSensor._ADC.read(0)
        return measure

    @staticmethod
    def get_pressure():
        pressure_value = 0
        for i in range(parameters.PRESSURE_SMOOTH_LENGTH):
            pressure_value += PressureSensor.read()
        pressure_measure = float(pressure_value) / PressureSensor._SMOOTH_FACTOR
        return pressure_measure
